Subject: Re: [PATCH] af_packet: Don't use skb after dev_queue_xmit()

From: Michael Breuer <[email-masked]>
Date: Sun, 17 Jan 2010 18:15:22 -0500

On 1/17/2010 6:05 PM, Jarek Poplawski wrote:
> On Sun, Jan 17, 2010 at 05:34:19PM -0500, Michael Breuer wrote:
>    
>> On 1/17/2010 5:17 PM, Jarek Poplawski wrote:
>>      
>>> On Sun, Jan 17, 2010 at 11:26:46AM -0500, Michael Breuer wrote:
>>>        
>>>> On 01/13/2010 04:16 PM, Michael Breuer wrote:
>>>>          
>>>>> On 1/13/2010 4:09 PM, Jarek Poplawski wrote:
>>>>>            
>>>>>> On Wed, Jan 13, 2010 at 03:39:37PM -0500, Michael Breuer wrote:
>>>>>>
>>>>>>              
>>>> Update: after leaving the system up for a few days, I hit the DMAR
>>>> error again.
>>>>          
>>> My proposal is to send some summary as a new thread, with dmar in the
>>> subject, and cc-ed dmar maintainers.
>>>
>>>        
>> Not sure I agree. The symptoms are identical to those I hit without
>> DMAR earlier on. Also, as this issue only happens when there is high
>> receive load, I'm thinking there's some sort of race between TX and
>> RX within the sky2 driver, or hardware. I think that DMAR is
>> correctly catching the error.
>>      
> Hmm... OK, then let's wait with this report and go back to testing
> it "really really long" ;-) without DMAR, and maybe without the
> last Stephen's patch either? (So only the two things in the current
> linux-2.6.)
>
> Jarek P.
>    
Ok - but absent the last patch, I think I still need the pskb_may_pull 
patch... so it'd be pskb_may_pull and afpacket v3 and no DMAR.

Also - not sure if related, but there's still the odd tx side behavior 
when RX is under load. That I CAN reproduce at will (yesterday's report 
- no crash, but I confirmed that DHCPOFFER packets are being dropped 
somewhere after wireshark sees them and before hitting the wire.

I am also wondering whether or not that testing I did yesterday set up 
today's hang - perhaps those lost TX packets are corrupting something 
that manifests worse later.